cd('scripts/')
load('control_amw_pcaF')
%% Create fpca
fpca = [];cnt = 1;
for i =1:length(pcaF)
        fpca(cnt,:) = pcaF{i};
        cnt = cnt+1;
end
%% Remove glomeruli
reUp = [];
glomsToInclude = [1:6,8:14,16];
for i = 0:16:length(fpca(1,:))-15
    temp = fpca(:,i+glomsToInclude);
    reUp(:,end+1:end+length(temp(1,:))) = temp;
end
fpca = reUp;
%% Replacing NaNs with mean values
tempF = [];
gloms = nanmean(fpca);
for i = 1:length(fpca(:,1))
    temp = find(isnan(fpca(i,:)));
    tempF(i,:) = fpca(i,:);
    for k = temp
        tempF(i,k) = gloms(k);
    end
end
fpca = tempF;
%% Z-score by glomerulus
pcaT = [];
glmLgth = length(glomsToInclude);
for i = 1:glmLgth
    glomTemp = i:glmLgth:glmLgth*12;
    glomTemp2 = fpca(:,glomTemp);
    glomMean = nanmean(glomTemp2(:));
    glomStd = nanstd(glomTemp2(:));
    pcaT(:,i:glmLgth:glmLgth*12) = (glomTemp2-glomMean)./glomStd;
end
fpca = pcaT;
%% Perform PCA on dataset.. remember.. the flies are the observations, and we are interested in reducing glomerular response (variables)
[coeff,score,latent,tsquared,explained,mu] = pca(fpca);
%%
a1 = rand(length(score(:,1)),3);
a1 = repmat([0.2 0.2 0.2],length(score(:,1)),1);
for i = 1:length(a1(:,1))
    if amw(i)
    %a1(i,:)= [0.5+(a1(i,1)*0.5),0.1,0.1];
    a1(i,:)= [0.5+(a1(1,1)*0.5),0.1,0.1];
    else
    a1(i,:)= [0.1,0.1,0.5+(a1(1,3)*0.5)];
    end
end
a1(1,:) = [0.8000    0.1000    0.1000];
%%
figTime = figure;cnt = 1;a2 = {};ccT = 0;
for i = 1:2:length(score(:,1))
    ccT = ccT+1;
    c3 = 300;
    cnt = cnt+1;
        a2{i} = scatter(score(i,1),score(i,2));hold on;
        a2{i}.MarkerFaceColor = a1(i,:);
        a2{i}.MarkerEdgeColor = a1(i,:);
        a2{i}.MarkerFaceAlpha = 0.75;
        a2{i}.SizeData = c3;
    
end
flyNames = {};
for i = 1:ccT
    if amw(i*2)
    flyNames{i} = strcat({'amwFly #'},num2str(i));
    flyNames{i} = flyNames{i}{1};
    else
        flyNames{i} = strcat({'cntrlFly #'},num2str(i));
    flyNames{i} = flyNames{i}{1};
    end
end
aLeg = legend(flyNames);
aLeg.AutoUpdate = 'off';
aLeg.Box = 'off';

%%
ccT = 0;
for i = 2:2:length(score(:,1))
    ccT = ccT+1;
    a7 = scatter(score(i,1),score(i,2));
    a7.MarkerFaceColor = a1(i-1,:);
    a7.MarkerEdgeColor = a1(i-1,:);
    a7.MarkerFaceAlpha = 0.75;
    a7.SizeData = c3;
    a3 = plot([score(i,1),score(i-1,1)],[score(i,2),score(i-1,2)]);
    a3.LineWidth = 2;a3.Color = a1(i-1,:); 
end
%axis(a500)
benFigureFormat_gen
pcaPercent = latent/sum(latent)*100;
a = xlabel(strcat('PCA 1','(',num2str(round(pcaPercent(1),2)),'%',')'));a.Position(2) = a.Position(2)-0.25;
a = ylabel(strcat('PCA 2','(',num2str(round(pcaPercent(2)),2),'%',')'));a.Position(1) = a.Position(1)-0.25;
%%
clear Cntrl_fullOdorPanel
clear AMW_fullOdorPanel
Control_fullOdorPanelPCs = score(~amw,:);
cnt = 2;
Cntrl_fullOdorPanel{1,1} = 'Fly ID';Cntrl_fullOdorPanel{1,2} = 'Odor panel 1';Cntrl_fullOdorPanel{1,3} = 'Odor panel 2';
for i = 1:2:length(Control_fullOdorPanelPCs(:,1))
    tempName = strcat({'Control fly'},num2str(cnt-1));Cntrl_fullOdorPanel{cnt,1} = tempName{1};
    Cntrl_fullOdorPanel{cnt,2} = Control_fullOdorPanelPCs(i,:);
    Cntrl_fullOdorPanel{cnt,3} = Control_fullOdorPanelPCs(i+1,:);
    cnt= cnt+1;
end
cntL = cnt-2;


Amw_fullOdorPanelPCs = score(logical(amw),:);
cnt = 2;
AMW_fullOdorPanel{1,1} = 'Fly ID';AMW_fullOdorPanel{1,2} = 'Odor panel 1';AMW_fullOdorPanel{1,3} = 'Odor panel 2';
for i = 1:2:length(Amw_fullOdorPanelPCs(:,1))
    tempName = strcat({'AMW fly'},num2str(cnt-1+cntL));AMW_fullOdorPanel{cnt,1} = tempName{1};
    AMW_fullOdorPanel{cnt,2} = Amw_fullOdorPanelPCs(i,:);
    AMW_fullOdorPanel{cnt,3} = Amw_fullOdorPanelPCs(i+1,:);
    cnt= cnt+1;
end


benDistCalc_gen
